﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StrategyAndFactory
{
    public abstract class Strategy
    {
        decimal _da;

        public decimal Da
        {
            get { return _da; }
            set { _da = value; }
        }
        decimal _db;

        public decimal Db
        {
            get { return _db; }
            set { _db = value; }
        }
        public abstract string AlgorithmInterface();
    }
    class ConcreteStrategyA : Strategy
    {
        
        public ConcreteStrategyA(decimal a,decimal b)
        {
            Da = a;
            Db = b;
        }
        public override string AlgorithmInterface()
        {
            return (Da*Db).ToString();
        }
    }
    class ConcreteStrategyB : Strategy
    {
        public ConcreteStrategyB(decimal a,decimal b)
        {
            Da = a;
            Db = b;
        }
        public override string AlgorithmInterface()
        {
            return (Da * Db - ((int) (Da * Db/300))*100).ToString();
        }
    }

    class ConcreteStrategyC : Strategy
    {
        public ConcreteStrategyC(decimal a,decimal b)
        {
            Da = a;
            Db = b;
        }
        public override string AlgorithmInterface()
        {
            return (Da * Db*0.8m).ToString();
        }
    }
    class Context
    {
        Strategy str;
        public Context(Strategy str)
        {
            this.str = str;
        }
        public string ContextInterface()
        {
            return str.AlgorithmInterface();
        }
    }
}
