﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace StrategyAndFactory
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            IntiCmb();
        }

        private void IntiCmb()
        {
            List<Cmb> list = new List<Cmb>();
            Cmb cmb = new Cmb();
            cmb.dm = "01";
            cmb.mc = "正常付款";
            list.Add(cmb);
            cmb = new Cmb();
            cmb.dm = "02";
            cmb.mc = "满300返100";
            list.Add(cmb);
            cmb = new Cmb();
            cmb.dm = "03";
            cmb.mc = "打8折";
            list.Add(cmb);

            cmbDz.ItemsSource = list;
            cmbDz.DisplayMemberPath = "mc";
            cmbDz.SelectedValuePath = "dm";
            cmbDz.SelectedIndex = 0;
        }
        decimal sum = 0;
        private void btnOk_Click(object sender, RoutedEventArgs e)
        {

            string val = cmbDz.SelectedValue.ToString();
            decimal a = decimal.Parse(tbDj.Text);
            decimal b = decimal.Parse(tbSs.Text);
            CashFactory cash = new CashFactory(a, b, val);
            rtbXx.Text += cash.str;
            sum += cash.sum;
            tbSum.Text = "金额合计：" + sum;

        }

        private void btnReset_Click(object sender, RoutedEventArgs e)
        {
            sum = 0;
            tbSum.Text = "金额合计：0";
            rtbXx.Text = "";
            tbDj.Text = "";
            tbSs.Text = "";
            cmbDz.SelectedIndex = 0;
        }
    }
    public class Cmb
    {
        public string dm { get; set; }
        public string mc { get; set; }
    }


    public class CashFactory
    {
        public string str { get; set; }
        public decimal sum { get; set; }
        public CashFactory(decimal a, decimal b, string type)
        {
            Context con;
            string aa;
            switch (type)
            {
                case "01":
                    con = new Context(new ConcreteStrategyA(a, b));
                    aa = con.ContextInterface();
                    str += "单价：" + a + ",数量：" + b + ",金额：" + aa + ",正常付款。" + "\n";
                    sum += decimal.Parse(aa);
                    break;
                case "02":
                    con = new Context(new ConcreteStrategyB(a, b));
                    aa = con.ContextInterface();
                    str += "单价：" + a + ",数量：" + b + ",金额：" + aa + ",满300返100。" + "\n";
                    sum += decimal.Parse(aa);
                    break;
                case "03":
                    con = new Context(new ConcreteStrategyC(a, b));
                    aa = con.ContextInterface();
                    str += "单价：" + a + ",数量：" + b + ",金额：" + aa + ",8折优惠。" + "\n";
                    sum += decimal.Parse(aa);
                    break;
                default:
                    break;
            }
        }
    }
}
